const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const user_uploads = sequelize.define(
    'user_uploads',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

title: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"uploaded",


"under_review",


"approved",


"rejected"

        ],

      },

content_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"ebook",


"document",


"audio",


"video"

        ],

      },

rejection_reason: {
        type: DataTypes.TEXT,
      
      

      },

uploaded_at: {
        type: DataTypes.DATE,
      
      

      },

reviewed_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  user_uploads.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity







































//end loop



    db.user_uploads.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });



    db.user_uploads.hasMany(db.file, {
      as: 'file_assets',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.user_uploads.getTableName(),
        belongsToColumn: 'file_assets',
      },
    });

    db.user_uploads.hasMany(db.file, {
      as: 'preview_images',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.user_uploads.getTableName(),
        belongsToColumn: 'preview_images',
      },
    });


    db.user_uploads.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.user_uploads.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return user_uploads;
};


